package ru.soune.nocopy.handler;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;
import ru.soune.nocopy.dto.BaseRequest;
import ru.soune.nocopy.dto.BaseResponse;
import ru.soune.nocopy.dto.MessageCode;
import ru.soune.nocopy.dto.statistic.ProtectedFilesStatisticResponse;
import ru.soune.nocopy.service.statistic.ProtectedFilesStatisticService;

@Component
@RequiredArgsConstructor
@Slf4j
public class StatisticProtectedFilesHandler implements RequestHandler {
    private final ProtectedFilesStatisticService statisticService;

    @Override
    public BaseResponse handle(BaseRequest request) throws Exception {
        ProtectedFilesStatisticResponse statistics = statisticService.getProtectedFilesStatistics();

        return new BaseResponse(
                request.getMsgId(),
                MessageCode.SUCCESS.getCode(),
                MessageCode.SUCCESS.getDescription(),
                statistics);
    }
}
